<template>
    <section>
        <flash-message transitionIn="animated swing" class="myCustomClass"></flash-message>

        <div style="margin-left: 10px !important;">

        <div class="row">
            <div class="col-12">
                <div class="col-md-5">
                    <div class="form-group" id="image_profile">
                        <p class="form-title-alt"><span class="red text-small">*</span>Profile Photo</p>

                        <img v-bind:src="avatar"  alt="Image preview..." id="previewOnPage"
                             class="circle-image-full">
                        <image-upload v-bind:avatar.sync="avatar"></image-upload>
                    </div>

                </div>
                <div class="col-md-7">
                    <div class="alert alert-info margin-bottom" role="alert" style="margin-top: 30px;">
                        Profile Photo Requirements:
                        <ul>
                            <li>Clear (not blurry or dark)</li>
                            <li>Only you in the photo</li>
                            <li>Cropped to your face or upper torso</li>
                            <li>Not wearing sunglasses/anything obstructing your face.</li>
                        </ul>
                    </div>
                </div>

            </div>
        </div>

        <div class="row margin-top-30">
                <div class="col-md-6">
                    <div class="form-group float-label-control">
                        <p class="form-title-alt"><span class="red text-small">*</span>First Name:</p>
                        <input type="text" v-model="currentUser.first_name" class="form-control" placeholder="First Name" required/>

                    </div>
                </div>
                <div class="col-md-6">
                    <div class="form-group float-label-control">
                        <p class="form-title-alt"><span class="red text-small">*</span>Last Name:</p>
                        <input type="text" v-model="currentUser.last_name" class="form-control" placeholder="Last Name" required />
                    </div>
                </div>
        </div>

        <!-- Email -->
        <div class="row margin-top-30">
                <div class="col-md-6">
                    <div class="form-group float-label-control">
                        <p class="form-title-alt"><span class="red text-small">*</span>Email:  </p>
                        <!-- If is driver -->
                        <div class="float-label-control" v-if="isDriver">
                            <input v-model="currentUser.email" readonly>
                            <p class="text-small medium-grey">You must contact us to change your email.</p>
                        </div>

                        <div v-if="!isDriver">
                            <input v-model="currentUser.email" class="form-control" placeholder="Email" required>
                        </div>


                    </div>
                </div>
                <div class="col-md-6">
                    <div class="form-group float-label-control">
                        <p class="form-title-alt"><span class="red text-small">*</span>PayPal Email:</p>
                        <input type="text" id="paypal" name="paypal_email" placeholder="Address"
                               class="form-control" v-model="currentUser.paypal_email">
                        <p class="text-small medium-grey">For receiving your driver payouts.</p>
                    </div>

                </div>
        </div>

        <!-- Phone & Country -->
        <div class="row margin-top-30">
            <div class="form-group float-label-control">

                <div class="col-md-4">

                    <p class="form-title-alt"><span class="red text-small" >*</span>Country Code:</p>
                    <div data-target="#countries" data-toggle="modal">
                        <input type="text" class="form-control" style="background-color: transparent"  v-model="currentUser.area_code" required>
                    </div>


                    <div id="countries" class="modal fade" role="dialog">
                        <div class="modal-dialog">
                            <!-- Modal content-->
                            <div class="modal-content" style="overflow: hidden">
                                <div class="modal-header">
                                    <button type="button" class="close" data-dismiss="modal">&times;</button>
                                    <h4 class="modal-title">Countries</h4>
                                </div>
                                <div class="modal-body" style="overflow-y: scroll; max-height: 400px;">
                                    <div class="padding-all-20">
                                        <label>Search country</label>
                                        <input type="text" class="form-control" v-model="searchCountry" placeholder="Search country.."/>

                                        <div class="row" style="margin-top: 10px; margin-bottom: 10px;" v-for="country in filteredList">
                                            <div class="col-sm-2 ">
                                                <p class="no-margin"> + {{country.calling_code}}</p>
                                            </div>
                                            <div class="col-sm-2 ">
                                                <p class="no-margin"><img :src="'/flags/' + country.flag" width="30px"></p>
                                            </div>
                                            <div class="col-sm-4">
                                                <p class="no-margin"> {{country.name}}</p>
                                            </div>
                                            <div class="col-sm-2 pull-right">
                                                <p class="btn btn-info x-slim-button" data-dismiss="modal" @click="selectCountry(country.calling_code)">Select</p>
                                            </div>
                                        </div>
                                    </div>

                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-md-8">
                    <p class="form-title-alt"><span class="red text-small">*</span>Phone Number:</p>

                    <input type="phone" id="phone_number" name="phone_number" placeholder="phone"
                               class="form-control" v-model="currentUser.phone_number">
                    <p class="text-small medium-grey">Please type numbers only, no () or -'s.</p>
                </div>
            </div>
        </div>

        <!-- Country Must Be first Because it determines the state -->
        <div class="row margin-top-30">
            <div class="form-group float-label-control">
                <div class="col-md-12">
                <p class="form-title-alt"><span class="white text-small">*</span>Country:</p>
                    <model-list-select :list="allCountries"
                                       v-model="currentUser.country"
                                       option-value="name"
                                       option-text="name"
                                       placeholder="select item"
                                       class="profile-form">
                    </model-list-select>
                </div>
            </div>
        </div>

        <!-- Address -->
        <div class="row margin-top-30">
            <div class="full-margin-10">
                <div class="form-group float-label-control">
                    <p class="form-title-alt"><span class="white text-small">*</span>Street Address:</p>
                    <input type="text" id="address" name="address" placeholder="Address"
                           class="form-control" v-model="currentUser.address">
                </div>
            </div>
        </div>

        <!-- City & State -->
        <div class="row top-margin-15">

                <div class="col-md-6">
                    <div class="form-group float-label-control">
                        <p class="form-title-alt"><span class="white text-small">*</span>City:</p>
                        <input type="text" id="city" name="city" placeholder="City"
                               class="form-control" v-model="currentUser.city">
                    </div>
                </div>
                <div class="col-md-6">
                    <div class="form-group float-label-control" id="states">
                        <p class="form-title-alt"><span class="white text-small">*</span>State/Province:</p>
                        <input type="text" id="state_input" name="state" placeholder="State" maxlength="2"  v-if="!isUSA"
                               class="form-control" v-model="currentUser.state" style="  text-transform: uppercase;">
                        <select  class="form-control" v-if="isUSA" v-model="currentUser.state">
                            <option v-bind:value="currentUser.state" selected>{{currentUser.state}}</option>
                            <option v-for="state in allStates" v-bind:value="state.code"> {{state.name}} </option>
                        </select>
                    </div>
                </div>
        </div>


        <div class="row margin-top-30">
                <div class="col-md-6">
                    <div class="form-group float-label-control">

                        <p class="form-title-alt"><span class="red text-small">*</span>Gender:</p>
                        <div v-if="isDriver">
                            <input v-model="currentUser.gender" readonly required>
                            <p class="text-small medium-grey">You must contact us to change your gender.</p>
                        </div>

                        <div v-if="!isDriver">
                            <select class="form-control" v-model="currentUser.gender">
                                <option v-bind:value="currentUser.gender" selected hidden>{{ currentUser.gender }}</option>
                                <option value="Male">Male</option>
                                <option value="Female">Female</option>
                            </select>
                        </div>
                    </div>
                </div>
                <div class="col-md-6">
                    <div class="form-group float-label-control">
                        <p class="form-title-alt"><span class="white text-small">*</span>Birth Year:</p>

                        <select class="form-control" v-model="currentUser.birthday" >
                            <option selected  v-bind:value="currentUser.birthday" > {{ currentUser.birthday }} </option>
                            <option v-for="year in years" v-bind:value="year"> {{year}}</option>
                        </select>

                    </div>
                </div>
        </div>

        <div class="row">
            <div class="col-12 full-margin-10">
                <div class="form-group float-label-control">
                    <p class="form-title-alt"><span class="red text-small">*</span>About Me:</p>
                    <textarea name="description" rows="5" class="form-control" v-model="currentUser.description">{{currentUser.description}}</textarea>
                </div>
            </div>
        </div>

        <div class="col-12 text-center">
            <button type="submit" id="submitButton" class="btn btn-primary" @click="editProfile()">Edit Profile</button>
        </div>

        </div>
    </section>
</template>

<script>

    import imageUpload from "./imageUpload";
    import { ModelListSelect } from 'vue-search-select'

    import 'vue-search-select/dist/VueSearchSelect.css'


    export default {
        components:{imageUpload, ModelListSelect},
        name: "profile",
        props:['user', 'countries', 'states'],
        mounted(){
            this.avatar = this.currentUser.avatar;

            if(this.currentUser.driver[0]){
                this.isDriver = true;
            }else{
                this.notDriver = true;
            }
            if(this.currentUser.area_code == null){
                this.currentUser.area_code = "+1";
            }else{
                this.currentUser.area_code = "+" + this.currentUser.area_code;
            }


            if(this.currentUser.country != 'United States'){
                this.isUSA = false;
            }else{
                this.isUSA = true;
            }
            for(var i=0; i < 85; i++){
                this.years[i] = (2000-i);
            }

            console.log(this.years);
        },
        data(){
            return{
                currentUser :JSON.parse(this.user),
                allCountries : JSON.parse(this.countries),
                allStates: JSON.parse(this.states),
                isDriver:false,
                notDriver:false,
                searchCountry:'',
                isUSA:false,
                years:[],
                avatar:''
            }
        },
        methods:{
            selectCountry:function(country){
                this.currentUser.area_code = "+" + country;
                $('#countries').modal('hide');

            },
            onChangeStaste(event){
                this.currentUser.state = event.targe.value;
            },
            editProfile(){
                axios.put('/dashboarduser/dashboarduser/' + this.currentUser.id, {
                    body: {
                        'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),
                        'user' : this.currentUser,
                    }
                }).then(response => {
                    this.flash(response.data['message'], response.data['status'],{timeout: 5000});
                    window.scrollTo({top: 0, behavior: 'smooth'});
                }).catch(e => {
                    this.flash('Server 500 error please try again', 'error',{timeout: 4500});
                    console.log(e);
                })
            },
        },
        computed: {
            filteredList() {
                return this.allCountries.filter(post => {
                    return post.name.toLowerCase().includes(this.searchCountry.toLowerCase())
                })
            }
        }
    }
</script>

<style scoped>

</style>